# Getting started with Flamingo

## Hello World Example
If you want to experience a very simple and basic Flamingo application then follow these steps:

1. Make sure you have Go >= 1.13 installed: https://golang.org/doc/install

2. Get the Flamingo "example-helloworld".
    ```
    git clone git@github.com:i-love-flamingo/example-helloworld.git
    ```
3. Run the application
    ```
    cd example-helloworld
    ```
    Your entry point is `main.go`, this is where the application is started. 
    During the first run, go will download all dependencies. 
    Flamingo uses [go modules](https://github.com/golang/go/wiki/Modules) for this.
        
     Run 
     ```
     go run main.go
     ``` 
     to see a list of possible commands.
     Run 
     ```
     go run main.go serve
     ``` 
     to start the Flamingo server and open [http://localhost:3322/](http://localhost:3322/)
    
## Flamingo from scratch

If you want to start a new project then follow these steps:

1. Initialize project
```bash
mkdir hello-flamingo && cd hello-flamingo
go mod init flamingo.me/hello-flamingo
```

2. Create initial `main.go` file
```go
package main

import (
	"flamingo.me/flamingo/v3"
)

func main() {
	flamingo.App(nil)
}
```

3. Run the code, the first time this will download and pin all necessary dependencies
```bash
go run main.go
```

## How to continue

* Start with [Hello World Tutorial](./2. Tutorial Hello World.md) to build your "Hello World" example step by step and learn some of Flamingo's features.
* Continue with [Hello Flamingo Carotene](https://github.com/i-love-flamingo/example-flamingo-carotene) to learn the features of the pug template engine and the flamingo-carotene frontend pipeline.
* Continue with the [Open Weather Example](https://github.com/i-love-flamingo/example-openweather) to learn how to build an application that connects to an external service step by step.


## Read through the Manuals

* Learn about all [Flamingo Basics](../2. Flamingo Core/1. Flamingo Basics/2. Flamingo Project Structure.html)
* Learn [Flamingo Framework Module Features](../2. Flamingo Core/2. Framework Modules/Configuration.html)
* Learn [Flamingo Core Module Features](../2. Flamingo Core/3. Core Modules/Cache.html)
